<?php 

/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
 
class Voiture 
{
	// les proprits de la classe prives, non accessibles par les autres classes
	private $sCouleur;
	private $sMarque;
	private $sType;
	
	private $iNombrePlaces;
	private $iNombrePortes;
	private $aOptions;
		
	// une proprit public accessible par les autres classes
	public $nom;
	
	
   /**
	* @brief Constructeur de la classe.
	* @param -
	*/
	public function __construct( $couleur, $marque, $type, $nbrePlaces, $nbrePorte, $options)
	{
		$this->sCouleur = $couleur;
		$this->sMarque = $marque;
		$this->sType = $type;

		$this->iNombrePlaces = $nbrePlaces;
		$this->iNombrePortes = $nbrePorte;
 	
 		$this->aOptions = array();
 		$this->aOptions = $options;
			
		$this->initNom("Premire voiture");			
	}

	// mthode prive non accessible par les autres classes.
	
	/**
	 * Dfinit le nom par dfaut de la voiture.
	 * 
	 */
	private function initNom($valeur)
	{
		$this->nom = $valeur;
	}
	
	
	// les mthodes de la classe accessibles par les autres classes
	public function changeCouleur( $sValeur)
	{
		$this->sCouleur = $sValeur;
		FirePHP::getInstance(true)->info($this->sCouleur, 'Nouvelle couleur');
	}
	
	
	/**
	 * Ajoute une option.
	 * 
	 */
	public function ajoutOption($valeur)
	{
		$this->aOptions[] = $valeur;
	}
	
			
	/**
	 * Renvoie toutes les informations de la voiture.
	 * 
	 */
	public function getDetails()
	{
		$sInformations = "<b>Nom:</b> ".$this->nom." - Couleur: ".$this->sCouleur." - <b>Marque:</b> ".$this->sMarque." - <b>Type:</b> ".$this->sType;
		$sInformations .= " - <b>Nombre de places:</b> ". (string) $this->iNombrePlaces." - <b>Nombre de portes:</b> ".(string) $this->iNombrePortes;		
		$sInformations .=" - <b>Les options:</b> ".implode(",", $this->aOptions);// implode permet de convertir un tableau en chaine de caractres

		return $sInformations;
	}
	
	
	/**
	 * Getter / setter pour modifier / lire le type de la voiture.
	 * 
	 */


	/**
	 * @brief redfinition de la mthode __get afin de dterminer comment la classe doit ragir lorsqu'on appelle une de ses proprits
	 * @param (string)	le nom de la proprit  retourner
	 * @return le contenu de la proprit
	 */
	public function __get($s_prop)
	{
		switch($s_prop)
		{
			case 'type' :
				return	$this->sType;
			
			default :// en cas d'erreur
				$s_message = 'la proprit '.$s_prop.' n\'existe pas dans la classe '.__CLASS__.'</br>';
				echo $s_message;
				return $s_message;
		}	
	}


	/**
	 * @brief redfinition de la mthode __set afin de dterminer comment la classe doit ragir lorsqu'on appelle un de ses attributs
	 * @param (string)	le nom de la proprit  modifier
	 * @param (-)	la nouvelle valeur de la proprit
	 * @return -
	 */
	public function __set($s_prop, $value)
	{	
		switch($s_prop)
		{
			case 'type' :
				$this->sType = $value;
				break;

			default :// en cas d'erreur
				echo 'SETTER la proprit '.$s_prop.' n\'existe pas dans la classe '.__CLASS__.'</br>';
		}
		
	}


		
	
	
 	/**
	* @brief Destructeur de la classe
	* Utilis pour enregistrer des messages pour le debogage, fermer les fichier ouverts en criture ou en lecture, raliser des oprations
	* de nettoyage des objets utiliss...
	*
	* @param 
	* @return 
	*/
	public function __destruct() 
	{
 
 	}



	/**
	 * @brief Dtermine comment la classe doit ragir lorsqu'elle est convertie en chaine de caractres.
	 * @usage   echo(myObject) ou print(myObject)
	 * @return  la reprsentation de l'objet sous forme de chaine.
	 */
	public function __toString() 
	{
		
		$s_classContent = "[Object ".__CLASS__."]<br />";
		// parcours toutes les proprits de la classe et les renvoie	
		foreach($this as $prop => $value) 
		{
		 	$s_classContent .= "$prop => $value <br />";
		}
		 
		return $s_classContent;
   	}

}
?>